### required data
tgl=2000 # total genetic length, subject to change
d # SNP data counts, 5-8 columuns are read counts for mutant-ref, mutant-alt, wildtype-ref and wildtype-alt

##Find estimated probability that a randomly selected
##SNP is in complete linkage disequilibrium with mutantgene.

dtor=function(d)
{
  r = 0.5 * (1 - exp(-2 * d))
  return(r)
}

cM=c(seq(0,20,by=0.01))
rf=dtor(cM/100)

#Set N to be the number of individuals in the mutant pool.
N=60 # subject to change

pnr=(1-rf)^(2*N)
plot(cM,pnr)

##This is numerical integration of P(no recomb|dist)P(dist)

ptheta0=sum(2*(0.01/tgl)*(pnr[-length(pnr)]+pnr[-1])/2)
ptheta0

##Find prior distribution of theta

thetahat=d[,6]/apply(d[,5:6],1,sum)
thetahat=c(thetahat,1-thetahat)

getppp=function(x)
{
  nm=sum(x[3:4])
  nw=sum(x[1:2])
  nonma=which.min(x[3:4])
  xm=min(x[3:4])
  xw=(x[1:2])[nonma]
  ##R="some recombinaton between SNP and causal gene in mutant pool"
  if(xm>0){
    ppmt=0
    ppwt=0
  }
  else{
    ##Find P(x1,x2|R)
    ##Integrate P(x1=0 or n|theta)prior(theta)
    p1=mean((1-thetahat)^nm+thetahat^nm)
    ##Find P(R|x1,x2)
    ppmt=(1/(1+p1*((1-ptheta0)/ptheta0)))
    ##Find P(wm,w) by integrating P(wm,w|theta)prior(theta) 
    p2=mean(dbinom(xw,nw,thetahat))
    ##Find P(wm,w|R)
    p3=mean(dbinom(xw,nw,thetahat[thetahat>=0.5]))
    ##Find P(R|wm,w)
    ppwt=.5*p3/p2
    ##Find the product of the posterior probabilities.
  }
  ppp=ppmt*ppwt
  c(ppmt,ppwt,ppp)
}

o=t(apply(d[,5:8],1,getppp))
##Columns are 
##posterior probability from mutant data,
##posterior probability from wild type data,
##product of the posterior probabilities.
